Commit e10d5b93 authored by Kroese's avatar Kroese Committed by GitHub
Browse files

feat: Allow installation on other architectures

parent 58346cd6
Loading
Loading
Loading
Loading
+36 −25
Original line number Diff line number Diff line
@@ -10,11 +10,12 @@ DL="https://global.synologydownload.com/download/DSM"
if [ -z "$URL" ]; then

  URL="$DL/release/7.2/64561/DSM_VirtualDSM_64561.pat"
  #URL="$DL/release/7.0.1/42218/DSM_VirtualDSM_42218.pat"
  #URL="$DL/release/7.1.1/42962-1/DSM_VirtualDSM_42962.pat"

fi

[ "$ARCH" != "amd64" ] && URL="$DL/release/7.0.1/42218/DSM_VirtualDSM_42218.pat"

# Check if output is to interactive TTY
if [ -t 1 ]; then
  PROGRESS="--progress=bar:noscroll"
@@ -36,7 +37,7 @@ rm -rf "$TMP" && mkdir -p "$TMP"

[[ "${DEBUG}" == [Yy1]* ]] && set -x

if [ ! -f "${RDC}" ]; then
if [ ! -f "${RDC}" ] && [ "$ARCH" == "amd64" ]; then

  info "Install: Downloading installer..."

@@ -68,6 +69,8 @@ if [ ! -f "${RDC}" ]; then

fi

if [ -f "${RDC}" ] && [ "$ARCH" == "amd64" ]; then

  { xz -dc <"$RDC" >"$TMP/rd" 2>/dev/null; rc=$?; } || :
  (( rc != 1 )) && error "Failed to unxz $RDC, reason $rc" && exit 91

@@ -91,6 +94,8 @@ chmod +x /run/extract/syno_extract_system_patch

  rm -rf "$TMP" && mkdir -p "$TMP"

fi

info "Install: Downloading $(basename "$URL")..."

PAT="/$BASE.pat"
@@ -110,12 +115,18 @@ fi
info "Install: Extracting downloaded image..."

if { tar tf "$PAT"; } >/dev/null 2>&1; then

  tar xpf "$PAT" -C "$TMP/."
  
else

  [ "$ARCH" != "amd64" ] && error "Wrong architecture: $ARCH" && exit 65
  
  export LD_LIBRARY_PATH="/run/extract"
  { /run/extract/syno_extract_system_patch "$PAT" "$TMP/."; rc=$?; } || :
  (( rc != 0 )) && error "Failed to extract PAT file, reason $rc" && exit 63
  export LD_LIBRARY_PATH=""
  
fi

HDA="$TMP/hda1"